/*
 * Copyright (c) 2002, 2004 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: t-error-0.c,v 1.6 2013/12/17 15:31:12 ca Exp $")

#include <stdio.h>

#include "sm/error.h"
#include "sm/sysexits.h"
#include "sm/test.h"

int
main(int argc, char *argv[])
{
	sm_error_T e1;
	int m, t, v, s;

	sm_test_begin(argc, argv, "test error 0");
	m = 0;
	t = 1;
	v = 1;
	e1 = sm_error_gen(m, t, v);
#if SM_T_DEBUG
	printf("e1=0x%x mod=%d, type=%d, value=%d\n", e1,
		sm_error_module(e1), sm_error_type(e1), sm_error_value(e1));
#endif /* SM_T_DEBUG */
	SM_TEST(sm_error_module(e1) == m);
	SM_TEST(sm_error_type(e1) == t);
	SM_TEST(sm_error_value(e1) == v);
	SM_TEST(!sm_is_ex_error(e1));

	m = 6;
	t = 1;
	v = 127;
	e1 = sm_error_gen(m, t, v);
#if SM_T_DEBUG
	printf("e1=0x%x mod=%d, type=%d, value=%d\n", e1,
		sm_error_module(e1), sm_error_type(e1), sm_error_value(e1));
#endif /* SM_T_DEBUG */
	SM_TEST(sm_error_module(e1) == m);
	SM_TEST(sm_error_type(e1) == t);
	SM_TEST(sm_error_value(e1) == v);
	SM_TEST(!sm_is_ex_error(e1));

	s = SM_SPCL_EX_;
	sm_error_add_spcl(e1, 1);
	SM_TEST(sm_error_module(e1) == m);
	SM_TEST(sm_error_type(e1) == t);
	SM_TEST(sm_error_value(e1) == v);
	SM_TEST(sm_error_spcl(e1) == s);
	SM_TEST(sm_is_ex_error(e1));

	m = 4;
	t = 3;
	v = 128;
	s = SM_SPCL_EX_;
	e1 = sm_error_gen_spcl(m, t, v, s);
	SM_TEST(sm_error_module(e1) == m);
	SM_TEST(sm_error_type(e1) == t);
	SM_TEST(sm_error_value(e1) == v);
	SM_TEST(sm_error_spcl(e1) == s);
	SM_TEST(sm_is_ex_error(e1));

	m = 4;
	v = EX_CONFIG;
	e1 = sm_ex_error(m, v);
	SM_TEST(sm_is_ex_error(e1));
	SM_TEST(sm_error_value(e1) == v);

	return sm_test_end();
}
