#!/bin/sh
# $Id: t-rel-toomany-0.sh,v 1.5 2010/02/16 17:01:38 ca Exp $
#
# ----------------------------------------
# test relaying: too often denied
# run smtpcnf.sh
# ----------------------------------------
#
#

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# cd to working directory for alias file!
cd ../qmgr || exit 1

#
if test -z "${NS}"
then
  echo "$0: no nameserver found"
  exit 1
fi

${CAT} > ${SMXCNF} <<EOF
qmgr { Log_Level = 12; wait_for_server=4; wait_for_client=4; }
smar { Log_Level = 12; nameserver = ${NS}; }
smtpc { Log_Level = 12; remote_port=${SNKPORT}; wait_for_server=4; }

smtps {
Log_Level = 12;
flags = {access};
daemon_address = localhost:${SRVPORT};
relay_from = "No.host.";
relay_to = "No.host.";
wait_for_server=4;
}
EOF

${CAT} > ${MT} <<EOF
x.y	[127.0.0.1]
a.b	[127.0.0.1]
EOF

# create access map
${CAT} > ${ACC} <<EOF
EOF
# create map
rm -f ${ACCMAP}
${MM} -t'	' -F ${ACCMAP} < ${ACC}

# run some test programs

# depend on maxbadcmd! XREF: SS_SESS_MAX_BADCMDS
# use s_cnf_sess_max_rjct to set it to known value here?

# ----------------------------------------
# relaying to address denied (only one address in the domain)
TEST=1
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false
if ${SHELL} ${SD}/smtpcnf.sh -Ssender${TEST}@a.b -R"r0@x.y -Rr1@x.y -Rr2@x.y -Rr3@x.y -Rr4@x.y -Rr5@x.y -Rr6@x.y -Rr7@x.y -Rr8@x.y -Rr9@x.y" -E 0 -X 0 -A 0 -c '-d 4'
then
  if ${GREP} '421 4.7.0 Too many' ${CLTL} >/dev/null
  then
    # depends on maxbadcmd! XREF: SS_SESS_MAX_BADCMDS
    if ${GREP} 'r4@' ${CLTL} >/dev/null
    then
      ERR=true
    fi
  else
    ERR=true
  fi
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
else
   ${VERBOSE} && echo "PASS: ${TEST}"
fi
fi

# ----------------------------------------
# relaying to address denied (only one address in the domain)
TEST=2
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false
if ${SHELL} ${SD}/smtpcnf.sh -Z smtpc2 -c '-Fa.b -Yx.y -m 10 -T 10 -x' -E 0 -X 0 -A 3 -c '-d 4'
then
  if ${GREP} '421 4.7.0 Too many' ${CLTL} >/dev/null
  then
    # depends on maxbadcmd! XREF: SS_SESS_MAX_BADCMDS
    if ${GREP} 'r4@' ${CLTL} >/dev/null
    then
      ERR=true
    fi
  else
    ERR=true
  fi
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
else
   ${VERBOSE} && echo "PASS: ${TEST}"
fi
fi


# ------
rm -f ${MTMAP}

# ----------------------------------------
# end
if test ${ERRS} -eq 0
then
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
