#!/bin/sh
# $Id: t-restart-dep-1.sh,v 1.9 2013/12/22 15:19:48 ca Exp $
#
# Copyright (c) 2011 Claus Assmann
#
# By using this file, you agree to the terms and conditions set
# forth in the license/LICENSE.3C file which can be found at the
# top level of this source code distribution.
#
# ----------------------------------------
# test restart functionality of mcp:
# don't restart anything because "server" failed fatally.
# ----------------------------------------

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../mcp
fi
L1=smtps.log
L2=qmgr.log
. ${SD}/common.sh

cat > ${CONF} <<EOF
smtps {
	start_action = wait; processes_min = 1; processes_max = 1;
	user = ${USER};
	path = ./t-restart;
	arguments = "t-restart -p ${PIDF1} -f ${R1} -n 3 -VV -s 4 -Ro";
}
qmgr {
	start_action = wait; processes_min = 1; processes_max = 1;
	user = ${USER};
	path = ./t-restart;
	restart_dependencies = {smtps};
	arguments = "t-restart -p ${PIDF2} -f ${R2} -n 2 -VV -s 2 -U";
}
EOF

echo 0 > ${R1}
echo 0 > ${R2}
./mcp -D -t -dddd ${CONF} > ${OUT} 2>&1 &
echo $! >> ${PIDS}

waitforfile ${PIDF1}
waitforfile ${PIDF2}

# give it time to restart
sleep 5

# check that programs behaved properly
if grep 'service=qmgr, status=server failed with unrecoverable error' ${OUT} >/dev/null
then
  :
else
  echo "$0: ERROR: missing 'unrecoverable error' in ${OUT}"
  ERRS=`expr ${ERRS} + 1 `
fi
C=`grep -c 'execl ./t-restart' ${OUT}`
if [ X"$C" != "X2" ]
then
  echo "$0: ERROR: wrong number of execl: ${C}"
  ERRS=`expr ${ERRS} + 1 `
fi

stopit
testend
