#!/bin/sh
# $Id: t-mt-e-0.sh,v 1.5 2013/09/23 21:01:42 ca Exp $
# Copyright (c) 2011 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ------------------------------------------------------------
# Description:
# mailertable routing tests by contacting SMAR, syntax errors in RHS
# uses t-smar-1 and startsmar.sh
# ------------------------------------------------------------
#

# path to programs
P=..
TPRG=./t-smar-1
SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../smar
fi
. ${SD}/common.sh

chkcto SM_HEAP_CHECK

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

rm -f ${SOCK} ${PIDS}

# prepare mailertable
${CAT} > ${MT} <<EOF
meta1.org	4
.meta1.org	5
.org		6
EOF

# start SMAR
${SHELL} ${SD}/startsmar.sh -o '-H 2' ${SMAROPTS} || exit 1

rm -f ${OUT} ${IP} ${OK}

TEST=1
# ----------------------------------------
${VALGRIND} ${TPRG} -T 1 -R 10 -VVVV '<a@meta1.org>' '<b@host.meta1.org>' '<c@meta2.org>' > ${OUT} 2>&1
if grep sm-conf ${OUT} >/dev/null
then
  ERRS=`expr ${ERRS} + 1 `
  echo "$0: test ${TEST} failed: found sm-conf in output"
fi

for i in `cat ${PIDS}`
do
  kill -USR1 ${i}
done

# stop SMAR
for i in `cat ${PIDS}`
do
  kill ${i}
done

# ----------------
# thanks kids for not following the POSIX standard...
if test X"`uname`" = "XLinux"
then
  killall smar
fi
#rm -f ${OUT} ${IP} ${OK}

exit ${ERRS}
