#!/bin/sh
# $Id: t-msgmod-2.sh,v 1.2 2006/10/05 04:27:40 ca Exp $
# Copyright (c) 2005 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test message body modifications: remove headers
# uses t-msgmod-0
# ----------------------------------------
#
test -s stop && exit 1
#

GREP=grep
ERR=false
ERRS=0
if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

TPRG=./t-msgmod-0
IN=msg-2.in
OK=msg-2.ok
OUT=msg-2.out


# ----------------------------------------
# test: remove header
TEST=1
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

cat > ${IN} <<EOF
From: a
To: b
Header: remove
Subject: c

body
.
EOF

cat > ${OK} <<EOF
From: a
To: b
Subject: c

body
.
EOF

for i in 1 2 3 4 5 6 7 8 9 10 16 32 128 256
do
  ${TPRG} -b ${i} -d 2 < ${IN} > ${OUT}
  if diff ${OK} ${OUT}
  then
     :
  else
     echo "$0: test ${TEST} failed for i=${i}"
     ERR=true
     break
  fi
done
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi

else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi


# ----------------------------------------
# test: remove header
TEST=2
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

cat > ${IN} <<EOF
Header0: remove0
From: a
To: b
Header1: remove1
	header 1 continued
Subject: c
	more subject
Header2: remove2

body
.
EOF

cat > ${OK} <<EOF
Header0: remove0
From: a
To: b
Subject: c
	more subject
Header2: remove2

body
.
EOF

for i in 1 2 3 4 5 6 7 8 9 10 16 32 128 256
do
  ${TPRG} -b ${i} -d 3 < ${IN} > ${OUT}
  if diff ${OK} ${OUT}
  then
     :
  else
     echo "$0: test ${TEST} failed for i=${i}"
     ERR=true
     break
  fi
done
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi

else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi

# ----------------------------------------
# test: remove header
TEST=3
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

cat > ${IN} <<EOF
Header0: remove0
From: a
To: b
Header1: remove1
	header 1 continued
Subject: c
	more subject
Header2: remove2

body
.
EOF

cat > ${OK} <<EOF
From: a
To: b
Header1: remove1
	header 1 continued
Subject: c
	more subject
Header2: remove2

body
.
EOF

for i in 1 2 3 4 5 6 7 8 9 10 16 32 128 256
do
  ${TPRG} -b ${i} -d 0 < ${IN} > ${OUT}
  if diff ${OK} ${OUT}
  then
     :
  else
     echo "$0: test ${TEST} failed for i=${i}"
     ERR=true
     break
  fi
done
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi

else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi


# ----------------------------------------
# test: remove header
TEST=4
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

cat > ${IN} <<EOF
Header0: remove0
From: a
To: b
Header1: remove1
	header 1 continued
Subject: c
	more subject
Header2: remove2

body
.
EOF

cat > ${OK} <<EOF
Header0: remove0
From: a
To: b
Header1: remove1
	header 1 continued
Subject: c
	more subject

body
.
EOF

for i in 1 2 3 4 5 6 7 8 9 10 16 32 128 256
do
  ${TPRG} -b ${i} -d 5 < ${IN} > ${OUT}
  if diff ${OK} ${OUT}
  then
     :
  else
     echo "$0: test ${TEST} failed for i=${i}"
     ERR=true
     break
  fi
done
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi

else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi




# ----------------------------------------
# end
if test "${ERRS}" = "0"
then
  rm -f ${IN} ${OK} ${OUT}
  exit 0
else
  echo "${ERRS} error(s)"
  exit 1
fi
