#!/bin/sh
# $Id: t-msgmod-7.sh,v 1.3 2008/01/28 00:01:02 ca Exp $
#
# ----------------------------------------
# test message body modifications
# uses t-msgmod-0
# ----------------------------------------
#
test -s stop && exit 1
#

GREP=grep
ERR=false
ERRS=0
if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

TPRG=./t-msgmod-0
IN=msg-7.in
OK=msg-7.ok
OUT=msg-7.out

# ----------------------------------------
# test: replace, remove header
TEST=1
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

cat > ${IN} <<EOF
Received: from someone
From: a
To: b
Subject: c

body
.
EOF

cat > ${OK} <<EOF
Received: hidden
From: a
To: b

body
.
EOF

${TPRG} -r '0=Received: hidden' -d 3 < ${IN} > ${OUT}
if diff ${OK} ${OUT}
then
   :
else
   echo "$0: test ${TEST} failed"
   ERR=true
fi

if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi

else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi




# ----------------------------------------
# end
if test "${ERRS}" = "0"
then
  rm -f ${IN} ${OK} ${OUT}
  exit 0
else
  echo "${ERRS} error(s)"
  exit 1
fi
