#!/bin/sh
# $Id: smtp6.sh,v 1.4 2011/07/08 15:38:50 ca Exp $
#
# host on which to listen/to which to send
H=::1
# port number to use
P=${MTA_SRVPORT:-1235}
ERRS=0
SRVL="smtps.log"
CLTL="smtpc.log"
rm -f $SRVL $CLTL
#
C="inet6:$P@[$H]"

SRV=./smtps2
CLT=./smtpc2

if [ X"${MTA_NO_IPV6_TEST}" != "X" ]
then
  echo "SKIPPED: $0: MTA_NO_IPV6_TEST set"
  exit 0
fi

for p in $SRV $CLT
do
  if $p -h  2>&1 | grep ' inet6' >/dev/null
  then
	:
  else
	echo "SKIPPED: $0: $p not compiled with MTA_NETINET6"
	exit 0
  fi
done

# start SMTP server
$SRV -b "$C" > $SRVL 2>&1 &
status=$?
SRVPID=$!
if [ "x$status" != "x0" ]
then
  echo "FAIL: cannot start server $status"
  exit $status
fi
sleep 3
if grep "ERROR" $SRVL > /dev/null
then
  echo "found ERROR in $SRVL"
  ERRS=`expr $ERRS + 1 `
fi

# send SMTP server a signal to dump its state
if kill -USR1 $SRVPID
then
  :
else
  echo "kill -USR1 failed: $?"
  exit 1
fi
sleep 2

# check state of SMTP server
if fgrep "$C" $SRVL > /dev/null
then
  :
else
  echo "failed to listen on $H:$P"
  ERRS=`expr $ERRS + 1 `
fi
if grep "^Thread.* 8/" $SRVL > /dev/null
then
  :
else
  echo "failed to start threads"
  ERRS=`expr $ERRS + 1 `
fi
if grep "^Waiting threads *8" $SRVL > /dev/null
then
  :
else
  echo "wrong number of waiting threads"
  ERRS=`expr $ERRS + 1 `
fi
if grep "^Busy threads *0" $SRVL > /dev/null
then
  :
else
  echo "wrong number of busy threads"
  ERRS=`expr $ERRS + 1 `
fi
if grep "^Sessions served *0" $SRVL > /dev/null
then
  :
else
  echo "wrong number of sessions"
  ERRS=`expr $ERRS + 1 `
fi

# send 100 messages: 10 connections, 10 threads
if ./smtpc2 -r "$C" -c 10 -t 10 > $CLTL 2>&1
then
  :
else
  cat $CLTL
  ERRS=`expr $ERRS + 1 `
fi

# ----------------
kill -TERM $SRVPID

[ $ERRS -eq 0 ] && exit 0
echo "$0: $ERRS error(s)"
exit 1
